/* =====> GEN <===== */

* {
    font-family: 'Courier New', Courier, monospace;
}

p {
    width: fit-content;
    margin: 0;
    padding: 0;
}

i {
    padding-left: 5px;
    padding-right: 5px;
}

.hidden {
    display:none !important;
}

b {
    font-weight: bold;
}

/* To center correctly those icon */
.bi-chevron-double-up, .bi-chevron-up, .bi-chevron-double-down, .bi-chevron-down {
    padding-bottom: 0.125rem;
}
.bi-chevron-double-up::before, .bi-chevron-up::before {
    padding-bottom: 0.0625rem; /* (0.125 / 2) */
}

.bi-book, .bi-globe2, .bi-eye-slash-fill, .bi-x, .bi-box-arrow-up-right {
    vertical-align: 0.125rem;
}

/* =====> TABLE STYLE <===== */

.table {
    table-layout: fixed;
}

.fix-baking-rights {
    width: 100%;
    overflow-x: scroll;
    display: block;
}

.fix-baking-rights td,
.fix-baking-rights th
{
    min-width: 150px;
    max-width: 150px;
}

.fix-baking-rights tbody,
.fix-baking-rights thead
{
    display: block;
}

.cell-min-width th,
.cell-min-width td {
    min-width: 150px;
}

table.th-sticky-left tbody th  {
    position: sticky;
    background-color: inherit;
    left: 0;
    z-index: 1;
}

table.th-sticky-top thead  {
    position: sticky;
    background-color: inherit;
    top: 0;
    z-index: 2;
}

table.th-sticky-left.th-sticky-top thead tr th:first-child  {
    position: sticky;
    background-color: inherit;
    top: 0;
    left: 0;
    z-index: 3;
}

.centered-header {
    display: flex;
    flex-direction: column;
    text-align: center;
    white-space: nowrap;
    text-align: center;
}

table.consensus-ops-table thead th.border-top {
    box-shadow: inset 0px 1px 0px black, inset 1px 0px 0px black, inset -1px 0px 0px black;
}

table.consensus-ops-table thead th.border-mid {
    box-shadow: inset 1px 0px 0px black, inset -1px 0px 0px black;
}

table.consensus-ops-table thead th.border-bot {
    box-shadow: inset 0px -1px 0px black, inset 1px 0px 0px black, inset -1px 0px 0px black;
}

table.consensus-ops-table thead th.border-bot-L {
    box-shadow: inset 0px -1px 0px black, inset 1px 0px 0px black;
}

table.consensus-ops-table thead th.border-bot-R {
    box-shadow: inset 0px -1px 0px black, inset -1px 0px 0px black;
}

table.consensus-ops-table thead tr:nth-child(1) {
    color: whitesmoke;
    background: #1b1b1b;
}

table.consensus-ops-table thead tr:nth-child(2) {
    color: whitesmoke;
    background: #272a2d;
}

table.consensus-ops-table thead tr:nth-child(3),
table.consensus-ops-table tbody th
{
    color: whitesmoke;
    background: #343a40;
}

.consensus-progression-tables {
    max-width: 250px;
    max-height: 256px;
    overflow-y: scroll;
    overflow-y: overlay;
    scroll-behavior: smooth;
    list-style-type: none;
    padding: 0;
    margin: 0 0.5rem;
}

.consensus-progression-tables li {
    max-width: fit-content;
}

.consensus-progression-tables .table-header {
    color: whitesmoke;
    background: #343a40;
    font-weight: bold;
}

.consensus-progression-tables th,
.consensus-progression-tables td {
    padding: .75rem;
    padding-right: 1.5rem;
    min-width: 250px;
}

.consensus-progression-scroll-button-container {
    position: absolute;
    bottom: 0;
    margin: 5px;
}

.consensus-progression-scroll-button-container i {
    margin-inline: 3px;
}

table thead.middle th {
    vertical-align: middle;
}

.table.no-padding td, .table.no-padding th {
    padding: 1px;
}


.table.no-border td, .table.no-border th {
    border: none;
}

/* =====> POSITIONING & SPACING <===== */

.center {
    display: flex;
    justify-content: center;
    align-items: center;
}

.horizontal-spreading {
    width: 100%;
    overflow-x: auto;
    text-align: center;
    display: flex;
    justify-content: space-between;
}

.inline-space-between {
    display:flex;
    justify-content: space-between;
}

.inline-left {
    display: flex;
    justify-content: start;
}

.inline-right {
    display: flex;
    justify-content: end;
}

.light-border-spacing {
    padding: 20px;
}

.light-margin-left {
    margin-left: 10px;
}

.light-margin-top {
    margin-top: 10px;
}

.light-margin-bottom {
    margin-bottom: 10px;
}

.light-margin {
    margin: 5px;
}

.medium-margin-bottom {
    margin-bottom: 20px;
}

.extra-light-margin-right {
    margin-right: 5px;
}

.extra-light-margin-top {
    margin-top: 3px;
}

@media (max-width:1500px) {
    .lb-min-width-1 {
        min-width: 150px !important;
    }
    .lb-min-width-2 {
        min-width: 300px !important;
    }
    .lb-min-width-3 {
        min-width: 500px !important;
    }
}

/* custom responsive nav-bar */

.nav-bar-network {
    margin: 15px 0px 0px 15px;
    width: 160px
}

.nav-bar-custom-toggle {
    display: -webkit-inline-box; 
    width: 100%;
}


@media (max-width: 929px) {
    .nav-bar-network {
        margin: 15px 10px 0px 15px;
        width: 160px
    }

    .hide-seperator {
        display: none;
    }

    .shrink-seperator {
        margin-left: 5px !important;
        margin-right: 5px !important;
    }
}

@media (max-width: 1490px) {
    .navbar-nav {
        flex-direction: inherit;
    }

    .nav {
        display: flex;
        flex-wrap: wrap;
        padding-left: 0;
        margin-bottom: 0;
        list-style: none;
        margin-top: 15px;
        margin-left: 10px;
    }

    .navbar-nav .dropdown-menu {
        position: absolute;
        float: none;
    }
}

.no-margin-padding {
    padding: 0;
    margin: 0;
}

.inline-ul li {
    display: inline;
}

.inline-block-ul li {
    display: inline-block;
    padding-right: 10px;
}

.title-spinner {
    display:flex;
    flex-direction: row;
    align-items: center;
} 

.spaced-spinner {
    margin-left: 20px;
}

.justified {
    text-align: justify;
}

.line {
    text-decoration: line-through;
}

.underline {
    text-decoration-line: underline;
}

tr.line-through td {
    position:relative
}

tr.line-through td:before {
  content: " ";
  position: absolute;
  left: 0; top: 50%; width: 100%;
  border-bottom: 1px solid #000;
}

.b-dropdown-text {
    white-space: nowrap;
}

.b-dropdown-text:hover {
    color: #16181b;
    text-decoration: none;
    background-color: #e9ecef;
}

/* =====> COLORS <===== */

.navigation-item a {
    color: whitesmoke !important;
}

thead tr, tbody th {
    color: whitesmoke;
    background-color: #343a40;
}

.black-fade-1 {
    background-color: black !important;
}

.black-fade-2 {
    background-color: rgb(27, 27, 27) !important;
}

.current-head {
    background: bisque;
}

.finalized-content {
    background: lightgreen;
}

.finalized-block {
    background: rgb(0, 160, 0);
}

.seen-alt-block {
    background: #FFC0CB;
    /*
        Mohamed's SPECIFIC request !
        Do NOT change it or bear the consequences...
    */
}

.darker-background-below {
    background-color: rgba(0, 0, 0, 0.05);
}

.text-orange {
    color: orange;
}

.text-darkorange {
    color: darkorange;
}

.text-blue {
    color: blue;
}

.text-green {
    color: green;
}

.text-red {
    color: red;
}

.centered-text {
    text-align: center;
}

.offline-baker {
    background: rgb(140, 140, 140);
}

.navbar-dark .navbar-nav .nav-link {
    color: whitesmoke;
}

.btn-dark {
    background-color:#6d6d6d
}

/* =====> TOOLTIP <===== */

.tooltip .tooltip-inner {
    background: #d7d7d7;
    color: black;
    max-width: 100%;
    padding: 5px 15px;
}

.tooltip.bs-tooltip-top .arrow::before {
    border-top-color: #d7d7d7;
}

.tooltip.bs-tooltip-bottom .arrow::before {
    border-bottom-color: #d7d7d7;
}

.tooltip.bs-tooltip-right .arrow::before {
    border-right-color: #d7d7d7;
}

.tooltip.bs-tooltip-left .arrow::before {
    border-left-color: #d7d7d7;
}

.tooltip.without-arrow .arrow {
    display: none !important;
}

.tooltip.hash-tooltip .tooltip-inner {
    display: flex;
    padding: 0 3px;
    font-size: .7rem;
}

.tooltip.hash-tooltip .tooltip-inner i {
    color: green;
    align-self: center;
    line-height: 0;
    padding: 0 5px 0 0;
}

.tooltip.cops-hd-tooltip {
    width: 25%;
}

.tooltip.cops-hd-tooltip .tooltip-inner {
    background-color: transparent;
    padding: 0;
}

.tooltip.cops-hd-tooltip .tooltip-inner .alert {
    margin: 0;
}

.tooltip.dal-tooltip .tooltip-inner {
    background-color: transparent;
    padding: 0;
}

.tooltip.dal-tooltip .tooltip-inner .alert {
    margin: 0;
}

/* =====> CUSTOM <===== */

[tabindex="-1"].btn-dark:focus:not(:disabled):not(.disabled):not(.active):not(:focus-visible) {
    background-color: #6d6d6d;
    border-color: var(--gray-dark);
    box-shadow: 0 0 transparent;
}

i.round-button {
    display: inline-block;
    border-radius: 50%;
}

.scroll-button {
    color: var(--white);
    background-color: rgb(140, 140, 140);
}

.clickable {
    cursor: pointer;
}

.clickable:hover {
    filter: brightness(125%);
}

.clickable:active {
    filter: brightness(75%);
}

.clickable.disabled, .clickable:disabled {
    cursor: default;
    filter: brightness(50%);
}

.title-bc {
    background-color: #343a40;
    color: #d7d7d7;
    border-radius: 10px;
    height: 50px;
    width: fit-content;
    justify-content: left;
    align-items: center;
    display: flex;
    padding-left: 20px;
    padding-right: 20px;
}

.settings {
    min-width: 500px;
    width: 50%;
    margin: auto;
}

.settings-box {
    background-color: #f2f2f2;
    border-radius: 10px;
    padding: 20px;
    margin-bottom: 30px;
}

.hash_shorten_settings_radio.btn-group {
    display: flex;
    align-items: center;
}

.hash_shorten_settings_radio .btn {
    border-radius: 10px !important; /* Required: to override boostrap-vue */
    background-color: #bdbdbd !important;  /* Required: to override boostrap-vue */
    color: black !important;  /* Required: to override boostrap-vue */
}

.hash_shorten_settings_radio .btn:not(:last-child) {
    margin-right: 10px;
}

.hash_shorten_settings_radio .btn.active {
    background-color: #b0b0b0 !important; /* Required: to override boostrap-vue */
    color: black !important; /* Required: to override boostrap-vue */
    border-color: #6a6a6a !important; /* Required: to override boostrap-vue */
    border-width: 5px;
}

.custom-round-timer {
    width: 150px;
    border-radius: 0.5rem;
    color: white;
    background: #343a40;
}

.nav-pills .nav-link.active {
    color: #fff;
    background-color: #343a40;
}

.vl {
    margin-top: 15px;
    margin-left: 25px;
    margin-right: 25px;
    border-left: 1px solid rgb(124, 124, 124);
    height: 40px;
}

.vl-info-bar {
    margin-left: 25px;
    margin-right: 25px;
    border-left: 1px solid rgb(124, 124, 124);
}

.info-bar-text {
    display: flex;
    flex-direction: column;
    font-size: 14px;
    text-align: center;
    white-space: nowrap;
}

.dropdown-toggle::after {
    margin-left: 5px;
    vertical-align: 0;
}

.legend-table div {
    border: solid .02rem lightgray;
    margin: 5px;
}


.small-legend-size {
    font-size: 15px;
    padding: 10px;
}

.legend-title {
    width: 50%;
}

.legend-table-no-border {
    display: flex;
    justify-content: flex-end;
    width: 50%;
}

.legend-table-no-border div {
    margin: 5px;
}

@media (max-width:1669px) {
    .inline-legend {
        display: block;
    }

    .legend-title {
        width: fit-content;
    }
    
    .legend-table-no-border {
        display: flex;
        width: fit-content;
    }
    
    .legend-table-no-border div {
        margin: 5px;
    }
}

.alert-protocol-injection-box-container {
    display: flex;
    justify-content: center;
    position: absolute;
    width: 100%;
}

.protocol-injection-box {
    background-color: #f0f0f0;
    padding: 5px 20px;
    border-radius: 5px;
    border: solid 1px #c6c6c6;
}

.dal-slot {
    width: 20px;
    height: 20px;
    outline: thin solid black;
}

.dal-desc {
    display: flex;
}

.dal-legend-header {
    display: flex;
    justify-content: space-between;
}

.dal-published {
    background-color: rgb(42, 106, 202);
}

.dal-not-published {
    background-color: grey;
}

.dal-attested {
    background-color: rgb(16, 192, 0);
}

.dal-not-attested {
    background-color: red;
}

@keyframes opacity-blinking {
    0% { opacity:1 }
    100% { opacity:0 }
}

.opacity-blinking {
    opacity: 0;
    animation:1s linear infinite opacity-blinking alternate;
}

.ellipsis-point {
    width: 7px;
    height: 7px;
    margin-right: 5px;
}

.consensus-progression-tables .protocol-injection-box {
    font-size: .9rem;
    white-space: break-spaces;
    text-align: center;
}

.table thead.centered th {
    text-align: center;
    vertical-align: middle;
}

/* tree-view */

.tree-box {
    width: 100%;
    min-height: 100px;
    max-height: 400px;
    overflow: auto;
    background-color: #f2f2f2;
    border-radius: 5px;
    padding: 2px;
}

.tree-box-content {
    background-color: #f2f2f2;
    border-radius: 5px;
    padding: 5px !important;
}

.tree, .tree ul {
    margin:0;
    padding:0;
    list-style:none
}
.tree ul {
    margin-left:1em;
    position:relative
}
.tree ul ul {
    margin-left:.5em
}
.tree ul:before {
    content:"";
    display:block;
    width:0;
    position:absolute;
    top:0;
    bottom:0;
    left:0;
    border-left:1px solid
}
.tree li {
    margin:0;
    padding:0 1em;
    line-height:2em;
    color:#369;
    --text-color: rgb(51, 102, 153);
    --faded-text-color: rgba(51, 102, 153, 0.6);
    font-weight:700;
    position:relative
}
.tree ul li:before {
    content:"";
    display:block;
    width:10px;
    height:0;
    border-top:1px solid;
    margin-top:-1px;
    position:absolute;
    top:1em;
    left:0
}
.tree ul li:last-child:before {
    background-color: #f2f2f2;
    height:auto;
    top:1em;
    bottom:0
}
.indicator {
    margin-right:5px;
}
.tree li a {
    text-decoration: none;
    color:#369;
}
.tree li button, .tree li button:active, .tree li button:focus {
    text-decoration: none;
    color:#369;
    border:none;
    background:transparent;
    margin:0px 0px 0px 0px;
    padding:0px 0px 0px 0px;
    outline: 0;
}

.triggerable .clickable {
    filter: none;
}

.triggerable {
    background-image:
	linear-gradient(
	    90deg,
	    var(--text-color, black) 0%,
	    var(--text-color, black) 50%,
	    var(--faded-text-color, rgba(0, 0, 0, 0.5)) 75%,
	    var(--text-color, black) 100%
	);
    background-size: 200% auto;
    background-clip: text;
    text-fill-color: transparent;
    -webkit-background-clip: text;
    -webkit-text-fill-color: transparent;
    animation: triggerable-animation 4s linear infinite;
    display: inline-block;
}

@keyframes triggerable-animation {
    50% {
	background-position: 0% center;
    }
    100% {
	background-position: 200% center;
    }
}

.scroll-shadows {
    overflow: scroll;

    background:
	/* Shadow Cover TOP */
	linear-gradient(
	    white 30%,
	    rgba(255, 255, 255, 0)
	) center top,

	/* Shadow Cover BOTTOM */
	linear-gradient(
	    rgba(255, 255, 255, 0),
	    white 70%
	) center bottom,

	/* Shadow Cover LEFT */
	linear-gradient(
	    to right,
	    white 30%,
	    rgba(255, 255, 255, 0)
	) left center,

	/* Shadow Cover RIGHT */
	linear-gradient(
	    to right,
	    rgba(255, 255, 255, 0),
	    white 70%
	) right center,

	/* Shadow TOP */
	radial-gradient(
	    farthest-side at 50% 0,
	    rgba(0, 0, 0, 0.2),
	    rgba(0, 0, 0, 0)
	) center top,

	/* Shadow BOTTOM */
	radial-gradient(
	    farthest-side at 50% 100%,
	    rgba(0, 0, 0, 0.2),
	    rgba(0, 0, 0, 0)
	) center bottom,

	/* Shadow LEFT */
	radial-gradient(
	    farthest-side at 0 50%,
	    rgba(0, 0, 0, 0.2),
	    rgba(0, 0, 0, 0)
	) left center,

	/* Shadow RIGHT */
	radial-gradient(
	    farthest-side at 100% 50%,
	    rgba(0, 0, 0, 0.2),
	    rgba(0, 0, 0, 0)
	) right center;

    background-repeat: no-repeat;
    background-size: 100% 80px, 100% 80px, 80px 100%, 80px 100%, 100% 40px, 100% 40px, 40px 100%, 40px 100%;
    background-attachment: local, local, local, local, scroll, scroll, scroll, scroll;
}
